
#include <stdlib.h>

#ifdef USE_PVM
#include <pvm3.h>
#endif /* USE_PVM */

#include "petrol.h"
#include "utils.h"

Individual *Roulette(Population *p) {
  int         n;
  double      partSum, mark;
  Individual *pop;

  pop = p->pop;

  mark = randFraction() * p->sumFitness;
  for (n = 0, partSum = 0.0; partSum <= mark && n < p->popSize; n++) {
    partSum += (pop + n)->fitness;
  }

  if (n == 0) {
    return (pop);
  } else {
    return (pop + n - 1);
  }

}

